add_action( 'save_post_post', 'ex_update_post', 10, 3 );

function ex_update_post($post_id, $post, $update) {

	//Check post_type, revision and autosave to prevent from calling twice
	if(get_post_type($post_id) == 'post' && ! wp_is_post_autosave($post_id) && ! wp_is_post_revision($post_id)) {

		//When post is trashed: update meta key to disable wpForo crossposting and return
		if ($update && $post->post_status == 'trash') {
			if (metadata_exists( 'post', $post_id, '_wpforo_crossposting_disabled')) {
				update_post_meta( $post_id, '_wpforo_crossposting_disabled', 1); 
				return;
			}		  
		}

		//When featured image is not set: use the first image and set as featured image
		if ($post instanceof WP_Post && ! has_post_thumbnail($post_id)) {

			$attached_image = get_children( "order=ASC&post_parent=$post->ID&post_type=attachment&post_mime_type=image&numberposts=1" );
			if ( $attached_image ) {
				$attachment_values = array_values( $attached_image );
				add_post_meta( $post_id, '_thumbnail_id', $attachment_values[0]->ID, true );
			}
		}

		//If NOT initiated from wpuf save/update: set metadata key _ex_xpost based on post category
		if (strpos(wp_debug_backtrace_summary(), 'WPUF_Frontend_Form->submit_post') == false) {

			//Check if metadata key _wpforo_crossposting_disabled exist: if not create it and set it to 1
			if ( ! metadata_exists( 'post', $post_id, '_wpforo_crossposting_disabled')) {
				add_post_meta($post_id, '_wpforo_crossposting_disabled', 1);
			} else {
				update_post_meta($post_id, '_wpforo_crossposting_disabled', 1);
			}

			//If post is in category "Local Post": set metadata key _wpforo_crossposting_disabled to 0
			$lv_postcat = get_the_category($post_id);
			if (! empty($lv_postcat)) {
				foreach ($lv_postcat  as $lv_catname) {  
					if ($lv_catname->name == 'Local Post') {
						update_post_meta($post_id, '_wpforo_crossposting_disabled', 0);			
					}
				}
			}		
		}

		//Check is crossposting forumid needs to be set
		if (get_post_meta($post_id, $key= '_wpforo_crossposting_disabled', $single = true) == 0 && !metadata_exists( 'post', $post_id, '_wpforo_crossposting_forumid')) {
			add_post_meta($post_id, '_wpforo_crossposting_forumid', 2);
		}
	}
}